import './index.css';
import nameGenerator from './name-generator';
import isDef from './is-def';

import {
    Sensor, Humidity, MesYeux, Light, Temperature, Data,
    TimeSeries,
    Datum
} from "./model.js";

//liste des capteurs
var list = []
//Pour l'affichage sur la page web 
let line, l1, l2, l3;
const messages = document.querySelector('#messages');
const messages1 = document.querySelector('#messages1');
const messages2 = document.querySelector('#messages2');
const messages3 = document.querySelector('#messages3');
line = document.createElement('li');
l1 = document.createElement('li');
l2 = document.createElement('li');
l3 = document.createElement('li');


var mqtt = require('mqtt')
//oon crée un client qui conecte le client à mqtt brocker
var client = mqtt.connect('mqtt://localhost:8080')

//une liste ou on stocke les sensor pour vérifier la répititivité 


//cette fonction permet au client de s'abonner au Broker mqtt pour récupérer tous ce que les capteurs difusent
client.on('connect', function () {
    client.subscribe('#')

})







client.on('message', function (topic, message) {

    createObject(message, topic);

})


/** cette fonction permet de creer ou mettre ajour un 
 * instance d'un capteure selon son identifiant
 * on les arrange dans un liste à chaque fois on 
 * verifie la redendance un capteurs s'il existe déja
 * on mis ajour sa valeur en la stoquant à l'aide de lobjet Timeseries 
 * et on calcul à chaque fois la moyenne des valeur
 * et on affiche tous sur un page web
 * 
 */

function createObject(message, topic) {

    var objet = JSON.parse(message.toString())
    var idSensor = topic.substring(6)
    var type = objet.type
    var existSensor = []
    var timeSerise = new TimeSeries()

    existSensor = sensorExite(list, idSensor)

    switch (idSensor) {
        case 'temperatureChambre':
            //s'il cette objet n'exite pas dans la liste 
            if (!existSensor[0]) {
                // objet de type Temperateur
                var temperature = new Temperature();
                temperature.id = topic.substring(6);
                temperature.valTemperature = objet.value;
                timeSerise.remplirListValues(temperature.valTemperature);
                temperature.timeSeries = timeSerise;

                temperature.date = new Date().toLocaleString();

                //on ajoute l'objet das la list des capteur
                list.push(temperature)


                //affichage

                l1.textContent = temperature.toString() + " || la  moyenne : " + temperature.timeSeries.moyenneValue()

            } else {
                console.log('mise à jour' + existSensor[1] + objet.value)
                list[existSensor[1]].valTemperature=objet.value
                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                list[existSensor[1]].date = new Date().toLocaleString();


                //affichage
                l1.textContent = list[existSensor[1]].toString() + " || la  moyenne : " + list[existSensor[1]].timeSeries.moyenneValue()
                messages1.appendChild(l1);
            }
            break
        case 'temperatureSalleA111':
            if (!existSensor[0]) {

                var temperature = new Temperature();



                temperature.id = topic.substring(6);
                temperature.valTemperature = objet.value;
                timeSerise.remplirListValues(temperature.valTemperature);
                temperature.timeSeries = timeSerise;

                temperature.date = Date.now().toLocaleString();

                list.push(temperature)

                //affichage
                line = document.createElement('li');
                line.textContent = temperature.toString() + " || la  moyenne : " + temperature.timeSeries.moyenneValue()




            } else {
                console.log('mise à jour' + existSensor[1] + objet.value)
                list[existSensor[1]].valTemperature=objet.value
                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                list[existSensor[1]].date = new Date().toLocaleString();





                line.textContent = list[existSensor[1]].toString() + " || la  moyenne : " + list[existSensor[1]].timeSeries.moyenneValue()
                messages.appendChild(line);
            }
            break

        case 'MonAttention':
            if (!existSensor[0]) {

                var humidity = new Humidity();



                humidity.id = topic.substring(6);
                humidity.valHumidity = objet.value;

                timeSerise.remplirListValues(humidity.valHumidity);
                humidity.timeSeries = timeSerise;

                humidity.date = Date.now();

                list.push(humidity)


                l2.textContent = humidity.toString() + " || la  moyenne : " + humidity.timeSeries.moyenneValue()



            } else {

                list[existSensor[1]].timeSeries.remplirListValues(objet.value)
                list[existSensor[1]].valHumidity=objet.value
                
                list[existSensor[1]].date = new Date().toLocaleString();


                l2.textContent = list[existSensor[1]].toString() + " ||la  moyenne : " + list[existSensor[1]].timeSeries.moyenneValue()
                messages2.appendChild(l2);

            }
            break

        case 'MesYeux':
            if (!existSensor[0]) {

                var mesYeux = new MesYeux();



                mesYeux.id = topic.substring(6);
                mesYeux.etat = objet.value;
                mesYeux.date = Date.now().toLocaleString();
                list.push(mesYeux)
                l3.textContent = mesYeux.toString()

            } else {
                list[existSensor[1]].etat = objet.value;
                list[existSensor[1]].date = new Date().toLocaleString();
                l3.textContent = list[existSensor[1]].toString();
                messages3.appendChild(l3);
            }
            break;

        default:
            console.log("Désolé, nous n'avons plus de captuer  ");
    }
}







/**
 * cette fonction verfier l'existance d'un sensor dans une liste de sensor déja existant
 * dans cette liste
 * @param {*} list list des sensor 
 * @param {*} idSensor identifiant du Sensor en cours
 */
function sensorExite(list, idSensor) {
    var obj = []
    var bool = false
    var ind = 0


    for (var i = 0; i < list.length; i++) {

        if (list[i].id === idSensor) {
            bool = true
            ind = i

        }




    }

    obj.push(bool)
    obj.push(ind)

    return obj;

}





// Store/retrieve the name in/from a cookie.
const cookies = document.cookie.split(';');
console.log(cookies)
let wsname = cookies.find(function (c) {
    if (c.match(/wsname/) !== null) return true;
    return false;
});
if (isDef(wsname)) {
    wsname = wsname.split('=')[1];
} else {
    wsname = nameGenerator();
    document.cookie = "wsname=" + encodeURIComponent(wsname);
}


// Set the name in the header
document.querySelector('header>p').textContent = decodeURIComponent(wsname);

// Create a WebSocket connection to the server
//const ws = new WebSocket("ws://" + window.location.host+ "/socket");

// We get notified once connected to the server*
/*ws.onopen = (event) => {
  console.log("We are connected.");
};*/
/*
// Listen to messages coming from the server. When it happens, create a new <li> and append it to the DOM.
const messages = document.querySelector('#messages');
let line;
client.onmessage = () => {
  line = document.createElement('li');
  line.textContent();
  messages.appendChild(line);
};*/



// Retrieve the input element. Add listeners in order to send the content of the input when the "return" key is pressed.
function sendMessage(event) {
    event.preventDefault();
    event.stopPropagation();
    if (sendInput.value !== '') {
        // Send data through the WebSocket
        client.send(sendInput.value);
        sendInput.value = '';
    }
}
const sendForm = document.querySelector('form');
const sendInput = document.querySelector('form input');
//sendForm.addEventListener('submit', sendMessage, true);
//sendForm.addEventListener('blur', sendMessage, true);

